%define anolis_release 2
%undefine __cmake_in_source_build

Summary: A PDF file viewer for the X Window System
Name: xpdf
Version: 4.04
Release: %{anolis_release}%{?dist}
License: (GPLv2 or GPLv3) and BSD
Epoch: 1
Url: http://www.xpdfreader.com/

Source0: http://www.xpdfreader.com/dl/%{name}-%{version}.tar.gz
# We have to pull the following CMap files out due to non-free license.
# CMap/Adobe-GB1-UCS2
# CMap/GBK-EUC-UCS2
# CMap/GBpc-EUC-UCS2
# CMap/GBpc-EUC-UCS2C
# Source3: http://www.xpdfreader.com/dl/xpdf-chinese-simplified.tar.gz
Source3: xpdf-chinese-simplified-2020-dec-22-NOCMAP.tar.gz
# CMap/Adobe-CNS1-UCS2
# CMap/B5pc-UCS2
# CMap/B5pc-UCS2C
# CMap/ETen-B5-UCS2
# Source4: http://www.xpdfreader.com/dl/xpdf-chinese-traditional.tar.gz
Source4: xpdf-chinese-traditional-2020-dec-22-NOCMAP.tar.gz
# CMap/90ms-RKSJ-UCS2
# CMap/90pv-RKSJ-UCS2
# CMap/90pv-RKSJ-UCS2C
# CMap/Adobe-Japan1-UCS2
# Source5: http://www.xpdfreader.com/dl/xpdf-japanese.tar.gz
Source5: xpdf-japanese-2020-dec-22-NOCMAP.tar.gz
# CMap/Adobe-Korea1-UCS2
# CMap/KSCms-UHC-UCS2
# CMap/KSCpc-EUC-UCS2
# CMap/KSCpc-EUC-UCS2C
# Source6: http://www.xpdfreader.com/dl/xpdf-korean.tar.gz
Source6: xpdf-korean-2020-dec-22-NOCMAP.tar.gz
# cyrillic and thai don't have CMap files to worry about.
Source7: ftp://ftp.foolabs.com/pub/xpdf/xpdf-cyrillic-2011-aug-15.tar.gz
Source8: ftp://ftp.foolabs.com/pub/xpdf/xpdf-thai-2011-aug-15.tar.gz
Source10: xpdf.desktop
Source11: xpdf.png
Source12: ftp://ftp.foolabs.com/pub/xpdf/xpdf-arabic-2011-aug-15.tar.gz
Source13: ftp://ftp.foolabs.com/pub/xpdf/xpdf-greek-2011-aug-15.tar.gz
Source14: ftp://ftp.foolabs.com/pub/xpdf/xpdf-hebrew-2011-aug-15.tar.gz
Source15: ftp://ftp.foolabs.com/pub/xpdf/xpdf-latin2-2011-aug-15.tar.gz
Source16: ftp://ftp.foolabs.com/pub/xpdf/xpdf-turkish-2011-aug-15.tar.gz

Patch3: xpdf-4.01-ext.patch
Patch9: xpdf-3.00-papersize.patch
Patch11: xpdf-4.01-crash.patch
Patch12: xpdf-4.01-64bit.patch
Patch15: xpdf-3.04-nocmap.patch
Patch25: xpdf-4.00-versionedlib.patch
Patch26: xpdf-4.02-urw-base35-fonts.patch
Patch27: xpdf-4.04-libpaper2.patch
Patch28: xpdf-4.04-GlobalParams-null-fix.patch
Patch29: xpdf-4.04-shared-xpdf-lib.patch

# Security patches
# Based on
# https://gitlab.freedesktop.org/poppler/poppler/commit/cdb7ad95f7c8fbf63ade040d8a07ec96467042fc
# https://gitlab.freedesktop.org/poppler/poppler/commit/bf4aae25a244b1033a2479b9a8f633224f7d5de5
Patch101: xpdf-4.02-CVE-2019-12360.patch

# Debian patches
Patch200: xpdf-4.02-permissions.patch
# Proper stream encoding on 64bit platforms
Patch203: fix-444648.dpatch

Requires: urw-fonts
Requires: xdg-utils
Requires: poppler-utils
Requires: xorg-x11-fonts-ISO8859-1-75dpi
Requires: xorg-x11-fonts-ISO8859-1-100dpi
Requires: qt5-qtsvg

BuildRequires: qt5-qtbase-devel, cmake
BuildRequires: freetype-devel >= 2.1.7
BuildRequires: fontconfig-devel
BuildRequires: desktop-file-utils
BuildRequires: libpaper-devel
BuildRequires: libpng-devel
BuildRequires: libXpm-devel
BuildRequires: cups-devel

Provides:  %{name}-chinese-simplified = %{version}-%{release}
Obsoletes: %{name}-chinese-simplified
Provides:  %{name}-chinese-traditional = %{version}-%{release}
Obsoletes: %{name}-chinese-traditional
Provides:  %{name}-korean = %{version}-%{release}
Obsoletes: %{name}-korean
Provides:  %{name}-japanese = %{version}-%{release}
Obsoletes: %{name}-japanese


%description
Xpdf is an X Window System based viewer for Portable Document Format
(PDF) files. Xpdf is a small and efficient program which uses
standard X fonts.

%package devel
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: libpaper-devel
Requires: fontconfig-devel, freetype-devel
Requires: libpng-devel
Summary: Development files for xpdf libraries

%description devel
Development files for xpdf libraries.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%setup -q -a 3 -a 4 -a 5 -a 6 -a 7 -a 8 -a 12 -a 13 -a 14 -a 15 -a 16
%patch3 -p1 -b .ext
%patch9 -p1 -b .papersize
%patch11 -p1 -b .crash
%patch12 -p1 -b .alloc
%patch25 -p1 -b .versionedlib
%patch26 -p1 -b .urw-font-fix
%patch27 -p1 -b .libpaper2
%patch28 -p1 -b .GlobalParams-null-fix
%patch29 -p1 -b .shared-xpdf-lib

# security patches
%patch101 -p1 -b .CVE-2019-12360

# debian patches
%patch200 -p1 -b .permissions
%patch203 -p1 -b .64bit-stream

# Comment out unused urlCommand option
sed -i 's|urlCommand|#urlCommand|g' doc/sample-xpdfrc

%build
find -name "*orig" | xargs rm -f

# This may seem pointless, but in the unlikely event that _sysconfdir != /etc ...
for file in doc/*.1 doc/*.5 xpdf-*/README; do
  sed -i -e 's:/etc/xpdfrc:%{_sysconfdir}/xpdfrc:g' $file
done
# Same action for _datadir.
for file in xpdf-*/README xpdf-*/add-to-xpdfrc; do
  sed -i -e 's:/usr/share/:%{_datadir}/:g' $file
  sed -i -e 's:/usr/local/share/:%{_datadir}/:g' $file
done

export CFLAGS="%{optflags} -fPIC"
export CXXFLAGS="%{optflags} -Wno-deprecated -fPIC"
%cmake -DMULTITHREADED=ON -DOPI_SUPPORT=ON -DXPDFWIDGET_PRINTING=1 -DSYSTEM_XPDFRC="%{_sysconfdir}/xpdfrc"

%cmake_build
%cmake_build --target xpdf

%install
mkdir -p $RPM_BUILD_ROOT%{_datadir}/xpdf/arabic \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/chinese-simplified \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/chinese-traditional \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/cyrillic \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/greek \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/hebrew \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/japanese \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/korean \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/latin2 \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/thai \
         $RPM_BUILD_ROOT%{_datadir}/xpdf/turkish \
         $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps

%cmake_install

# Y U NO INSTALL LIBS?!?
mkdir -p $RPM_BUILD_ROOT%{_libdir}
cp -a %{_vpath_builddir}/fofi/libfofi.so* $RPM_BUILD_ROOT%{_libdir}
cp -a %{_vpath_builddir}/goo/libgoo.so* $RPM_BUILD_ROOT%{_libdir}
cp -a %{_vpath_builddir}/splash/libsplash.so* $RPM_BUILD_ROOT%{_libdir}
cp -a %{_vpath_builddir}/xpdf/libxpdfcore.so* $RPM_BUILD_ROOT%{_libdir}

# headers
mkdir -p $RPM_BUILD_ROOT%{_includedir}/xpdf/fofi
mkdir -p $RPM_BUILD_ROOT%{_includedir}/xpdf/goo
mkdir -p $RPM_BUILD_ROOT%{_includedir}/xpdf/splash
cp -a fofi/*.h $RPM_BUILD_ROOT%{_includedir}/xpdf/fofi/
cp -a goo/*.h $RPM_BUILD_ROOT%{_includedir}/xpdf/goo/
cp -a splash/*.h $RPM_BUILD_ROOT%{_includedir}/xpdf/splash/
cp -a xpdf/*.h $RPM_BUILD_ROOT%{_includedir}/xpdf/
cp -a %{__cmake_builddir}/aconf.h $RPM_BUILD_ROOT%{_includedir}/xpdf/
cp -a aconf2.h $RPM_BUILD_ROOT%{_includedir}/xpdf/

mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications/
desktop-file-install            \
        --dir $RPM_BUILD_ROOT%{_datadir}/applications   \
        --add-category X-Fedora                         \
        %{SOURCE10}
install -m 0644 %{SOURCE11} $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/xpdf.png

cp -pr xpdf-arabic/* $RPM_BUILD_ROOT%{_datadir}/xpdf/arabic/
cp -pr xpdf-chinese-simplified/* $RPM_BUILD_ROOT%{_datadir}/xpdf/chinese-simplified/
cp -pr xpdf-chinese-traditional/* $RPM_BUILD_ROOT%{_datadir}/xpdf/chinese-traditional/
cp -pr xpdf-cyrillic/* $RPM_BUILD_ROOT%{_datadir}/xpdf/cyrillic/
cp -pr xpdf-greek/* $RPM_BUILD_ROOT%{_datadir}/xpdf/greek/
cp -pr xpdf-hebrew/* $RPM_BUILD_ROOT%{_datadir}/xpdf/hebrew/
cp -pr xpdf-japanese/* $RPM_BUILD_ROOT%{_datadir}/xpdf/japanese/
cp -pr xpdf-korean/* $RPM_BUILD_ROOT%{_datadir}/xpdf/korean/
cp -pr xpdf-latin2/* $RPM_BUILD_ROOT%{_datadir}/xpdf/latin2/
cp -pr xpdf-thai/* $RPM_BUILD_ROOT%{_datadir}/xpdf/thai/
cp -pr xpdf-turkish/* $RPM_BUILD_ROOT%{_datadir}/xpdf/turkish/

# poppler provides all utilities now
rm $RPM_BUILD_ROOT%{_bindir}/pdfdetach
rm $RPM_BUILD_ROOT%{_bindir}/pdffonts
rm $RPM_BUILD_ROOT%{_bindir}/pdfimages
rm $RPM_BUILD_ROOT%{_bindir}/pdfinfo
rm $RPM_BUILD_ROOT%{_bindir}/pdftohtml
rm $RPM_BUILD_ROOT%{_bindir}/pdftops
rm $RPM_BUILD_ROOT%{_bindir}/pdftotext
rm $RPM_BUILD_ROOT%{_bindir}/pdftoppm
rm $RPM_BUILD_ROOT%{_mandir}/man1/pdftoppm.1*
rm $RPM_BUILD_ROOT%{_mandir}/man1/pdfdetach.1*
rm $RPM_BUILD_ROOT%{_mandir}/man1/pdffonts.1*
rm $RPM_BUILD_ROOT%{_mandir}/man1/pdfimages.1*
rm $RPM_BUILD_ROOT%{_mandir}/man1/pdfinfo.1*
rm $RPM_BUILD_ROOT%{_mandir}/man1/pdftohtml.1*
rm $RPM_BUILD_ROOT%{_mandir}/man1/pdftops.1*
rm $RPM_BUILD_ROOT%{_mandir}/man1/pdftotext.1*

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/xpdf/
for i in arabic chinese-simplified chinese-traditional cyrillic greek hebrew japanese korean latin2 thai turkish; do
     mv $RPM_BUILD_ROOT%{_datadir}/%{name}/$i/README README.$i
     mv $RPM_BUILD_ROOT%{_datadir}/%{name}/$i/add-to-xpdfrc $RPM_BUILD_ROOT%{_sysconfdir}/xpdf/add-to-xpdfrc.$i
done

# xpdfrc cleanup
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/
cp -a doc/sample-xpdfrc $RPM_BUILD_ROOT%{_sysconfdir}/xpdfrc
sed -i -e 's:/usr/local/share/:%{_datadir}/:g' $RPM_BUILD_ROOT%{_sysconfdir}/xpdfrc

%generate_compatibility_deps

%files
%license COPYING COPYING3
%{_bindir}/xpdf
%{_bindir}/pdftopng
%{_libdir}/lib*.so.*
%{_mandir}/man?/pdftopng*
%{_mandir}/man?/xpdf*
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdfrc
%dir %{_sysconfdir}/xpdf
%lang(ar) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.arabic
%lang(zh_CN) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.chinese-simplified
%lang(zh_TW) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.chinese-traditional
%lang(el) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.greek
%lang(iw) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.hebrew
%lang(ja) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.japanese
%lang(ko) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.korean
%lang(th) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.thai
%lang(tr) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.turkish
# cyrillic and latin2 are not langs, many languages are cyrillic/latin2
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.cyrillic
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.latin2
%{_datadir}/icons/hicolor/48x48/apps/xpdf.png
%dir %{_datadir}/xpdf
%{_datadir}/applications/*
%lang(ar) %{_datadir}/xpdf/arabic
%lang(zh_CN) %{_datadir}/xpdf/chinese-simplified
%lang(zh_TW) %{_datadir}/xpdf/chinese-traditional
%lang(el) %{_datadir}/xpdf/greek
%lang(iw) %{_datadir}/xpdf/hebrew
%lang(ja) %{_datadir}/xpdf/japanese
%lang(ko) %{_datadir}/xpdf/korean
%lang(th) %{_datadir}/xpdf/thai
%lang(tr) %{_datadir}/xpdf/turkish
%{_datadir}/xpdf/cyrillic
%{_datadir}/xpdf/latin2
%dir %{abidir}
%{abidir}/libfofi.dump
%{abidir}/libgoo.dump
%{abidir}/libsplash.dump
%{abidir}/libxpdfcore.dump

%files devel
%{_includedir}/xpdf/
%{_libdir}/lib*.so

%files doc
%doc CHANGES README README.*

%changelog
* Thu Mar 30 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 1:4.04-2
- Del Specific Fields

* Thu Feb 16 2023 happy_orange <songnannan@linux.alibaba.com> - 1:4.04-1
- package import to anolis23
